# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import langlib
import popuplib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# * VARIABLES

folder = 'sam/base/addons/'
db     = 'sam_addons'
db_dir = 'cstrike/cfg/sam/databases/es_sam_addons_db.txt'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Keygroup ###
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.dbfiles)
	else: es.keygroupcreate(db)

	### Load Addons ###
	if len(getAddonsList()) > 0:
		for item in getAddonsList():
			if isAddonReg(item):
				if int(es.keygetvalue(db, item, 'status')) == 1:
					es.load(folder + item)
					updateAddon(item)
			else: regAddon(item)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Deletes ###
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	### Unloads ###
	for item in getAddonsList():
		if int(es.ServerVar('sam_' + item)) == 1: es.unload(folder + item)

	### Popups ###
	func.popupDelete('addonsList')
	func.popupDelete('addonsPage')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('addonsList')
	popup = popuplib.easymenu('addonsList', None , addonPage)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: %s' % func.lang_titles('addons_addonsList_desc'))
	if len(getAddonsList()) > 0:
		for item in getAddonsList():
			if not isAddonReg(item): regAddon(item)
			addon = getAddon(item)
			popup.addoption(addon, addon['name'])
		popup.submenu(10, 'mainPage')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_addons('no_addons_found'))
		block = es.import_addon('sam/base')
		block.displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addonPage(userid, addon, popup):
	func.popupDelete('addonsPage')
	global temp
	temp  = '%s_%s' % (userid,addon['basename'])
	func.popupDelete('addonsPage')
	popup = popuplib.create('addonsPage')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: %s' % func.lang_titles('addons_name'))
	popup.addline(func.pline)
	popup.addline(' # %s: %s' % (func.lang_word('name'), addon['name']))
	popup.addline(' # %s: %s' % (func.lang_word('version'), addon['version']))
	popup.addline(' ')
	popup.addline(' :: %s ::\n- %s.' % (func.lang_word('description'), func.lang_addonsDesc(addon['basename'])))
	popup.addline(' ')
	popup.addline(func.pline)
	if int(es.ServerVar('sam_' + addon['basename'])) == 1: popup.addline('->1. ' + func.lang_word('status').upper() + ': [ %s ] | %s' % (func.lang_word('on'),func.lang_word('off')))
	else: popup.addline('->1. ' + func.lang_word('status').upper() + ': %s | [ %s ]' % (func.lang_word('on'),func.lang_word('off')))
	popup.addline(func.pline)
	popup.addline('->8. %s' % func.lang_word('back'))
	popup.addline(' ')
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.menuselect = addonPageChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addonPageChoice(userid, choice, popup):
	if choice in range(1,4):
		addon = getAddon(temp.replace('%s_' % (userid),''))
		if es.ServerVar('sam_' + addon['basename']) == 1: addonUnload(userid, addon)
		else: addonLoad(userid, addon)
		es.keygroupsave(db, func.dbfiles)
		addonPage(userid, addon, None)
	elif choice in range(4,8) or choice in [9,10]: func.popupDelete(popup)
	else:
		block = es.import_addon('sam/base/addons')
		block.modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def addonLoad(userid, addon):
	if es.ServerVar('sam_' + addon['basename']) == 0:
		es.load(folder + addon['basename'])
		es.set('sam_' + addon['basename'], 1)
		es.keysetvalue(db, addon['basename'], 'status', 1)
		func.hudhint(userid, func.lang_addons('addon_now_enabled', {'addon':addon['name']}))
	else: func.hudhint(userid, func.lang_addons('addon_is_enabled', {'addon':addon['name']}))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addonUnload(userid, addon):
	if es.ServerVar('sam_' + addon['basename']) == 1:
		es.unload(folder + addon['basename'])
		es.set('sam_' + addon['basename'], 0)
		es.keysetvalue(db, addon['basename'], 'status', 0)
		func.hudhint(userid, func.lang_addons('addon_now_disabled', {'addon':addon['name']}))
	else: func.hudhint(userid, func.lang_addons('addon_is_disabled', {'addon':addon['name']}))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAddonsList():
	dir        = es.getAddonPath('sam') + '/base/addons/'
	addonsList = []
	for item in os.listdir(dir):
		if os.path.isdir(dir + item) == True: addonsList.append(item)
	return addonsList

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isAddonReg(addon):
	if es.exists('key', db, addon) == True: return True
	else: False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regAddon(addon):
	es.load(folder + addon)
	block            = es.import_addon(folder + addon)
	info             = {}
	info['name']     = block.addon.name
	info['basename'] = block.addon.basename
	info['version']  = block.addon.version
	if es.exists('key', db, addon) == 0: es.keycreate(db, addon)
	for item in info: es.keysetvalue(db, addon, item, info[item])
	es.keysetvalue(db, addon, 'status', block.addon.status)
	es.keygroupsave(db, func.dbfiles)
	if int(es.keygetvalue(db, addon, 'status')) == 0: es.unload(folder + addon)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def updateAddon(addon):
	block = es.import_addon(folder + addon)
	es.keysetvalue(db, addon, 'version', block.addon.version)
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAddon(addon):
	return {
			'name':es.keygetvalue(db, addon, 'name'),
			'version':es.keygetvalue(db, addon, 'version'),
			'basename':es.keygetvalue(db, addon, 'basename'),
			'status':es.keygetvalue(db, addon, 'status')
			}

# ============================================================================================================================================================= #