# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import keyvalues
import playerlib
import popuplib
import langlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

temp = {'toggle':'yes'}

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### Popups ###
	func.popupDelete('manager')
	func.popupDelete('manager_getTarget')
	func.popupDelete('manager_edit')
	
# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def modulePopup(userid):
	func.popupDelete('manager')
	popup = popuplib.create('manager')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: %s' % func.lang_titles('manager_name'))
	popup.addline(func.pline)
	popup.addline('->1. %s' % func.lang_admins('add'))
	popup.addline('->2. %s' % func.lang_admins('remove'))
	popup.addline('->3. %s' % func.lang_admins('edit_admin'))
	popup.addline(' ')

	'''
	popup.addline(' :: Admin Groups')
	popup.addline(func.pline)
	popup.addline('->4. Add a Group')
	popup.addline('->5. Delete a Group')
	popup.addline('->6. Edit Group')
	popup.addline(' ')
	'''

	popup.addline(func.pline)
	popup.addline('->8. %s' % func.lang_word('back'))
	popup.addline(' ')
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.submenu(8, 'mainPage')
	popup.menuselect = managerChoice
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ---------------------------------------------------------------------------------------------------------------------------------------------------- #
def managerChoice(userid, choice, popup):
	func.popupDelete('manager_getTarget')
	if choice in range(1,4):
		if choice == 1: popup   = popuplib.easymenu('manager_getTarget', None, addChoice)
		elif choice == 2: popup = popuplib.easymenu('manager_getTarget', None, remChoice)
		elif choice == 3: popup = popuplib.easymenu('manager_getTarget', None, editChoice)
		choices = {1:'add',2:'remove',3:'edit'}
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s\n# %s' % (func.lang_titles('manager_name'), func.lang_titles('manager_%s_admin_desc' % choices[choice])))
		if choice == 1:
			for player in playerlib.getPlayerList('#human'): popup.addoption(player, player.name)
		elif choice > 1:
			for admin in keyvalues.getKeyGroup(admins.db): popup.addoption(admin, es.keygetvalue(admins.db, admin, 'name'))
			es.set('sam_%s_setimmunity' % userid, 0)
		popup.submenu(8, 'manager')
		popup.send(userid)
	else:
		if choice < 8: modulePopup(userid)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def addChoice(userid, choice, popup):
	target = playerlib.getPlayer(choice)
	if admins.isAdmin(target.steamid) == False:
		admins.add(target.steamid)
		editChoice(userid, target.steamid, popup)
		func.hudhint(userid, func.lang_admins('admin_added', {'target':target.name}), func.admins_hudtag)
	else:
		func.hudhint(userid, func.lang_admins('is_admin', {'admin':target.name}), func.admins_hudtag)
		modulePopup(userid)
	func.popupDelete(popup)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remChoice(userid, choice, popup):
	if admins.isAdmin(choice):
		admin  = admins.getAdmin(choice)
		tokens = {'name':admin['name']}
		func.hudhint(userid, func.lang_admins('admin_removed'), func.admins_hudtag)
		admins.remove(userid, choice)
	else: func.tell(userid, func.lang_admins('not_an_admin'), func.adminstag)
	modulePopup(userid)
	func.popupDelete(popup)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def editChoice(userid, choice, popup, page = None):
	if not str(choice).startswith('STEAM'): choice = es.getplayersteamid(choice)
	admin = admins.getAdmin(choice)
	es.set('sam_%s_setimmunity' % (userid), 0)
	if admin:
		func.popupDelete('manager_edit')
		popup = popuplib.easymenu('manager_edit', None, editAdmin_Choice)
		popup.c_beginsep = func.pline + '\n# %s: %s\n# ID: %s\n ' % (func.lang_word('name'),admin['name'], choice)
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_admins('edit_admin'))
		popup.addoption({'item':'toggle','admin':admin}, func.lang_admins('toggle_all', {'state':func.lang_word(temp['toggle'])}))
		popup.addoption({'item':'immunity','admin':admin}, '%s: %s' % (func.lang_word('immunity'), admin['immunity']))
		for item in admins.access: popup.addoption({'item':item,'admin':admin}, '%s: %s' % (item, func.lang_word(admin[item])))
		popup.submenu(10, 'manager')
		if page != None: popup.sendPage(userid, page)
		else: popup.send(userid)
	else:
		func.tell(userid, func.lang_admins('not_an_admin'))
		modulePopup(userid)
	func.popupDelete(popup)

# ---------------------------------------------------------------------------------------------------------------------------------------------------- #
def editAdmin_Choice(userid, choice, popup):
	admin = choice['admin']
	data  = admins.access
	if choice['item'] not in ('toggle','immunity'): page = func.getPage(admins.access.index(choice['item']) + 2, 7)
	else: page = 1
	var = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(var) == 0:
		if choice['item'] == 'toggle':
			for item in admins.access: es.keysetvalue(admins.db, admin['steamid'], item, temp['toggle'])
			es.keygroupsave(admins.db, 'sam/databases')
			if temp['toggle'] == 'yes': temp['toggle'] = 'no'
			else: temp['toggle'] = 'yes'
			editChoice(userid, admin['steamid'], popup, page)
		elif choice['item'] == 'immunity':
			var.set(1)
			temp[userid] = admin['steamid']
			es.addons.registerSayFilter(setImmunity)
			func.tell(userid, func.lang_admins('immunity_get_value'), func.adminstag)
		else:
			if es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'yes': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'no')
			elif es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'no': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'yes')
			es.keygroupsave(admins.db, 'sam/databases')
			editChoice(userid, admin['steamid'], popup, page)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def setImmunity(userid, text, teamonly):
	var = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(var) == 1:
		target = temp[userid]
		if not text == '!cancel':
			try:
				if int(text) in range(0,101):
					var.set(0)
					es.keysetvalue(admins.db, target, 'immunity', int(text))
					es.keygroupsave(admins.db, 'sam/databases')
					editChoice(userid, target, None)
					es.addons.unregisterSayFilter(setImmunity)
				else: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
			except: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
		else:
			var.set(0)
			es.addons.unregisterSayFilter(setImmunity)
			editChoice(userid, target, None)
		return (0, 0, 0)

# ============================================================================================================================================================== #