# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import time
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

mutetag = '#greenMUTE'

# Keygroups
db     = 'sam_mutelist'
db_dir = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

# Mute Lengths
lengths = {
		  'b5 Minutes':300,
		  'c30 Minutes':1800,
		  'd1 Hour':3600,
		  'e3 Hours':10800,
		  'f1 Day':86400,
		  'g3 Days':259200,
		  'h1 Week':604800,
		  'aperm':'perm'
		  }

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Keygroups ###
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.dbfiles)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unload Keygroups ###
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	### Popups ###
	func.popupDelete('mute')
	func.popupDelete('plist')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	if os.path.isfile('cstrike/addons/sourcemod/plugins/basecomm.smx') == True:
		func.popupDelete('plist')
		popup = popuplib.easymenu('plist', None, plistChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_mute_desc'))
		for ply in playerlib.getPlayerList('#human'):
			if isMuted(ply.steamid) == True: popup.addoption(ply, '%s [Muted]' % (ply.name))
			else: popup.addoption(ply, ply.name)
		popup.submenu(10, 'pcontrol')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('mute_sm_not_found'), func.error)
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def plistChoice(userid, choice, popup):
	if admins.checkImmunity(es.getplayersteamid(userid), choice):
		if isMuted(choice.steamid) == False:
			# TEMP LIST
			templist = []
			for x in lengths: templist.append(x)
			templist.sort()

			func.popupDelete('mute')
			popup = popuplib.easymenu('mute', None, muteChoice)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_getTime_desc',{'func':'Mute'}))
			for item in templist: popup.addoption({'target':choice, 'time':lengths[item]}, func.lang_pcontrol(item.replace(item[0], '')))
			popup.submenu(10, 'pcontrol')
			popup.send(userid)
		else:
			es.keydelete(db, choice.steamid)
			es.keygroupsave(db, func.dbfiles)
			muteTarget('unmute', choice.name)
			func.tell('#human', func.lang_pcontrol('mute_unmuted_target',{'target':choice.name}), mutetag)
			block = es.import_addon('sam/base/pcontrol')
			block.function(userid, 'Mute', None)
	else:
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def muteChoice(userid, choice, popup):
	target = choice['target']
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target.steamid) == 0: es.keycreate(db, target.steamid)

	if choice['time'] == 'perm': status = 'perm'
	else: status = int(time.time()) + choice['time']

	es.keysetvalue(db, target.steamid, 'name', target.name)
	es.keysetvalue(db, target.steamid, 'stamp', status)
	es.keygroupsave(db, func.dbfiles)
	muteTarget('mute', target.name)

	func.tell('#human', func.lang_pcontrol('mute_muted_target',{'target':target.name}), mutetag)
	block = es.import_addon('sam/base/pcontrol')
	block.function(userid, 'Mute', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def muteTarget(cmd, target):
	var = int(es.ServerVar('sm_show_activity'))
	es.server.insertcmd('sm_show_activity 0')
	es.server.insertcmd('sm_%s %s' % (cmd, target))
	es.server.insertcmd('sm_show_activity %i' % var)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isMuted(target):
	if es.exists('key', db, target):
		if es.keygetvalue(db, target, 'stamp') == 'perm': return True
		elif int(es.keygetvalue(db, target, 'stamp')) > int(time.time()): return True
		else:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
			return False
	else: return False

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if isMuted(ev['es_steamid']) == True: muteTarget('mute', es.getplayername(ev['userid']))

# ============================================================================================================================================================= #